#include <stdint.h>

/* bcr6: This implementation is taken directy from the paper at:
 *
 * http://www.cl.cam.ac.uk/ftp/users/djw3/tea.ps
 */
void tea_encipher_32(uint32_t *const v,uint32_t *const w,
   const uint32_t *const k)
{
   register uint32_t       y=v[0],z=v[1],sum=0,delta=0x9E3779B9,
				a=k[0],b=k[1],c=k[2],d=k[3],n=32;

   while(n-->0)
   {
      sum += delta;
      y += ((z << 4)+a) ^ (z+sum) ^ ((z >> 5)+b);
      z += ((y << 4)+c) ^ (y+sum) ^ ((y >> 5)+d);
   }

   w[0]=y; w[1]=z;
}

#ifndef __AVR_ATtiny2313__

void tea_decipher_32(uint32_t *const v,uint32_t *const w,
   const uint32_t *const k)
{
   register uint32_t       y=v[0],z=v[1],sum=0xC6EF3720,
				delta=0x9E3779B9,a=k[0],b=k[1],
				c=k[2],d=k[3],n=32;

   /* sum = delta<<5, in general sum = delta * n */
   while(n-->0)
   {
      z -= ((y << 4)+c) ^ (y+sum) ^ ((y >> 5)+d);
      y -= ((z << 4)+a) ^ (z+sum) ^ ((z >> 5)+b);
      sum -= delta;
   }
   
   w[0]=y; w[1]=z;
}

#endif
