#include <stdint.h>

#ifndef __AVR_ATtiny2313__
	#define DDRLED  DDRA
	#define PORTLED PORTA
	#define PINLED  PINA
	#ifdef READER
             #define LEDTX      0
             #define LEDRX      1
	#else
             #define LEDTX      2            /* Should be pin # of anode of LED */
             #define LEDRX      1            /* Should be pin # of cathode of LED */

	#endif



#else

		#define DDRLED  DDRB
		#define PORTLED PORTB
		#define PINLED  PINB
#define LEDTX      0
#define LEDRX      1

#endif


// Times (what our time counters reach... based on 100µs intervals)


// Maximum length of a single message
#define LEDCOMM_MAXRXBUF 30


/* Call once and only once, and before any of the LEDcomm functions */
void ledcomm_init();

/* Returns 1 if we are synchronized with another LEDcomm unit, 0 otherwise.
   Not blocking. */
uint8_t ledcomm_client_present();

/* Returns the number of bytes currently in the LEDcomm RX buffer */
uint8_t ledcomm_rx_len();
/* Returns location of the LEDcomm RX buffer */
volatile char* ledcomm_get_rxbuf();
/* Clears the LEDcomm RX buffer */
void ledcomm_rx_reset();

/* Transmits nbytes bytes from the buf buffer over the LEDcomm interface
   Returns 1 for all bytes TX'd, or -1 for error.  Blocks. */
int8_t ledcomm_send_buffer(char *buf, uint8_t nbytes);

/* Shuts down the LEDcomm subsystem (including depowering LED)
   or restarts it */
void ledcomm_sleep();
void ledcomm_unsleep();

/* This needs to be called every 100 microseconds from an 
 * interrupt for the ledcomm subsystem to work */
void ledcomm_tick();
