#include <avr/sfr_defs.h>
#include <stdint.h>

#if 0
#define WIEGAND_WRITE_PORT PORTD
#define WIEGAND_WRITE_PIN1 1
#define WIEGAND_WRITE_PIN0 2
#endif

#define WIEGAND_WRITE_PORT PORTC
#define WIEGAND_WRITE_PIN1 3
#define WIEGAND_WRITE_PIN0 4

#define set_bit(x,b) (x |= _BV(b))
#define unset_bit(x,b) (x &= ~_BV(b))
#define get_bit(x,b) ((x & _BV(b)) >> b)

struct wiegand26 {
	uint8_t facility;
	uint16_t card;
};

struct wiegand30 {
	uint8_t facility;
	uint16_t serial;
	uint16_t card;
};

void wiegand_timer_tick();
void wiegand_init();
unsigned char wiegand_read(unsigned char max_bits, char *buf);
int wiegand_write(char *mem, int len);

/**
 * returns: 0 on success, -1 on checksum failure
**/
int wiegand26_unpack(char *mem, struct wiegand26 *out);

void wiegand26_pack(struct wiegand26 *in, char *out);

int wiegand30_unpack(char *mem, struct wiegand30 *out);
